//+------------------------------------------------------------------+
//|                                                    Trailling.mq4 |
//|                                         Copyright  2008, Kharko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Kharko"
#property link      ""

#property indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Aqua
#property  indicator_color2  Yellow

extern int    
      Bar       = 100,       // 
      Trailling = 100;         // 

double 
      UpBuffer[],
      DownBuffer[];
double 
      MaxExt=0,
      MinExt=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
//---- 2 indicator buffers mapping
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DownBuffer);
   SetIndexShift(0,0);
   SetIndexShift(1,0);

   IndicatorShortName("Trailling ("+Trailling+")");
   SetIndexLabel(0,"Up "+Trailling);
   SetIndexLabel(1,"Down "+Trailling);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if(counted_bars>0) counted_bars--;
   int limit=Bar-counted_bars;

   if(limit<1)limit=1;
   UpBuffer[0]=0;
   DownBuffer[0]=0;
   UpBuffer[1]=0;
   DownBuffer[1]=0;
//---- 
   for(int i=limit; i>=0; i--)
   {
      if(Correction(i)==1)return(0);
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int Correction(int sh)
  {
   double Max,Min,Max1,Min1;
  
//----
   Max=High[sh];   
   Min=Low[sh];   
   Max1=High[sh-1];   
   Min1=Low[sh-1];   

   if(Max!=0 && Min!=0 && Max1!=0 && Min1!=0)
   {
      if(MaxExt==0 || MaxExt<Max)
         MaxExt=Max;
      if(MinExt==0 || MinExt>Min)
         MinExt=Min;

//      Print(MaxExt," ",MinExt);
      if(NormalizeDouble(MaxExt-Trailling*Point,Digits)<Min1)
         UpBuffer[sh]=1;
      else
      {
         UpBuffer[sh]=0;
         MaxExt=0;
      }
      if(NormalizeDouble(MinExt+Trailling*Point,Digits)>Max1)
         DownBuffer[sh]=-1;
      else
      {
         DownBuffer[sh]=0;
         MinExt=0;
      }
   }
   else return(1);
//----
   return(0);
  }

